#!/usr/bin/env python3
# -*- coding: utf-8 -*-

def txt2bwt(text):
    n = len(text)
    text *= 2

    tuples = sorted([(text[i:i+16], i) for i in range(n)])
    k = 16
    while True:
        done, c, rank = True, 0, n*[0]
        for i in range(1, n):
            if tuples[i][0] != tuples[i-1][0]: c += 1
            else: done = False
            rank[tuples[i][1]] = c
        if done: break

        tuples = sorted([((rank[i] << 32) + rank[(i + k) % n], i) for i in range(n)])
        k *= 2

    return "".join(text[x-1] for (_, x) in tuples)

def bwt2txt(bwt):
    n = len(bwt)
    F, F_jump, rank = 256*[0], 257*[0], n*[0]
    for (i, c) in enumerate(bwt):
        rank[i] = F[ord(c)]
        F[ord(c)] += 1
    for i in range(256): F_jump[i+1] = F_jump[i]+F[i]

    txt, i = ['\x00'], 0
    for _ in range(n-1):
        txt.append(bwt[i])
        i = F_jump[ord(bwt[i])] + rank[i]

    return "".join(txt[::-1])

with open("SH.txt") as f:
    line = f.readline() + "\x00"

bwt = txt2bwt(line)
text = bwt2txt(bwt)
assert(line == text)

runs, prev = 0, ''
for c in bwt:
    if prev != c: prev, runs = c, runs + 1
print(runs)
